package com.winhc.repal.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.winhc.repal.entity.RepalGroup;
import com.winhc.repal.enums.DeletedStatusEnum;
import com.winhc.repal.enums.RoleTypeEnum;
import com.winhc.repal.model.dto.InitGroupDTO;
import com.winhc.repal.repository.RepalGroupMapper;
import com.winhc.repal.service.RepalGroupMemberService;
import com.winhc.repal.service.RepalGroupService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Objects;

/**
 * @description RepalGroup 接口实现类
 * @author Generator
 * @date 2022-04-13
 */
@Service
public class RepalGroupServiceImpl extends ServiceImpl<RepalGroupMapper, RepalGroup> implements RepalGroupService {

    @Autowired
    private RepalGroupMemberService repalGroupMemberService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean initGroup(InitGroupDTO dto) {
        RepalGroup repalGroup = this.getOne(Wrappers.lambdaQuery(RepalGroup.class)
                .eq(RepalGroup::getUserId, dto.getUserId())
                .eq(RepalGroup::getDeleted, DeletedStatusEnum.NORMAL.getCode()));
        if (Objects.isNull(repalGroup)) {
            repalGroup = new RepalGroup();
            repalGroup.setGroupName(dto.getGroupName());
            repalGroup.setUserId(dto.getUserId());
            this.save(repalGroup);
            repalGroupMemberService.addGroupMember(dto.getUserId(), repalGroup.getId(), 1L, RoleTypeEnum.SYSTEM.getCode());
        }
        return true;
    }
}
